local name, GHC = ...

local addon = LibStub("AceAddon-3.0"):GetAddon(GHC.addon_name)


local function getPlayerData(entry)
    return function(info)
        local guildspace = addon:GetGuildspace()
        if not guildspace then return nil end

        local guid = UnitGUID("player")
        if not guid then return nil end

        local player = guildspace.Roster[guid]
        if not player then return nil end

        local value = player[entry]
        addon:Debug(("get player[%s] = %s"):format(entry, tostring(value)))
        return value
    end
end


local function setPlayerData(entry)
    return function(info, value)
        local guildspace = addon:GetGuildspace()
        if not guildspace then return end

        local guid = UnitGUID("player")
        if not guid then return end

        local player = guildspace.Roster[guid]
        if not player then return end

        addon:Debug(("set player[%s] = %s"):format(entry, tostring(value)))
        player[entry] = value

        addon:SendMyData()
    end
end


local options = {
    type = "group",
    -- get = function(info) addon:Print("get") end,
    -- set = function(info, val) addon:Print("set", val) end,
    args = {
        characterRole = {
            order = 100,
            name = "Character role",
            desc = "Select character role(s)",
            type = "select",
            get = getPlayerData("Role"),
            set = setPlayerData("Role"),
            values = {
                -- nil,
                "DPS",
                "Healer",
                "Tank",
                "DPS-Healer",
                "DPS-Tank",
                "Healer-Tank",
                "Any",
                "Guild Bank",
            }
        },
        mainCharacterName = {
            order = 110,
            name = "Main character name",
            desc = "Enter your main's name",
            type = "input",
            multiline = false,
            get = getPlayerData("MainsName"),
            set = setPlayerData("MainsName"),
        },
        autoSendCharacterData = {
            order = 120,
            width = "double",
            name = "Auto send character data",
            desc = "Allowing this option will send your characters data whenever you gain a skill in a profession or level up!",
            type = "toggle",
            get = function(info) local val = addon.db.global.AutoSendCharacterData; addon:Debug("get", val); return val end,
            set = function(info, val) addon:Debug("auto send character data:", val); addon.db.global.AutoSendCharacterData = val end,
        }
    }
}

local AceConfigRegistry = LibStub("AceConfigRegistry-3.0")
AceConfigRegistry:RegisterOptionsTable(name, options, false)

local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local f = AceConfigDialog:AddToBlizOptions(name, GHC.addon_name, nil)
